#include "onewaylist.h"
#include <cstdlib>
#include <stdexcept>

Node::Node(): data(0),next(nullptr) {}
Node::Node(wchar_t value): data(value),next(nullptr) {}
OnewayList::OnewayList(): head(nullptr) {}
OnewayList::OnewayList(wchar_t value) {
#ifdef UNIQUE
        head = std::make_unique<Node>(value);
#else
        head = new Node(value);
//double* arr = new double[1000000000000];
#endif
}

void OnewayList::append(wchar_t value) {
    if (head == (NULL)) {
        head=
#ifdef UNIQUE
            std::make_unique<Node>(value);
#else
            new Node(value);
//double* arr = new double[1000000000000];
#endif

        return;
    }
    Node* temp=head
#ifdef UNIQUE
        .get()
#endif
        ;
    while (temp->next != nullptr) {
        temp=temp->next
#ifdef UNIQUE
                   .get()
#endif
            ;
    }
    temp->next=
#ifdef UNIQUE
            std::make_unique<Node>(value);
#else
            new Node(value);
//double* arr = new double[1000000000000];
#endif
}
bool OnewayList::remove(unsigned int pos, bool soft) {
    if (!head){
        if (soft)return 0; else throw std::runtime_error("Trying to remove element in a empty list");
    }
    
    if (pos == 0) {
        Node* temp=head
#ifdef UNIQUE
                         .get()
#endif
            ;if (head->next)head=
#ifdef UNIQUE
                std::move(head->next)
#else
                head->next
#endif
                ;else head = nullptr;//Ми нічого не втрачаємо, адже адреса голови досі в head.
#ifndef UNIQUE                       //також видаляємо те, що було в head. Без цього не можна,
        delete temp;                 //адже в Node є статичні поля, в яких щось має бути -
#endif                               //Якщо лишити там, наприклад, 0 - це теж буде ключем.
        return 1;                    //до того ж, це править момент з head == nullptr вище
    }                                //і ми точно зннаємо, що значення там відсутнє.
    Node* prev;
    Node* current=head
#ifdef UNIQUE
    .get()
#endif
            ;unsigned int index = 0;
    for (unsigned int i=0;i<pos;i++){if(current==nullptr)throw std::out_of_range("Trying to remove non-exiting element");prev=current
        ;current=current->next
#ifdef UNIQUE
        .get()
#endif
        ;}
    
    if (current->next)prev->next=
#ifdef UNIQUE
            std::move(current->next);
#else
            current->next;
    delete current;
#endif
    return 1;
}

wchar_t OnewayList::get(unsigned int pos, bool soft)const
{
    //std::cout<<"Looking for"<<pos;
    Node* temp = head
#ifdef UNIQUE
                     .get()
#endif
        ;
    wchar_t index = 0;
    while (temp != nullptr && index != pos) {
        temp=temp->next
#ifdef UNIQUE
                   .get()
#endif
            ;index++;
    }
    
    if (temp == nullptr){if (soft) return 0;else throw std::runtime_error("Trying to acces non-exiting key");}
        return temp->data;
}
#ifndef UNIQUE
OnewayList::~OnewayList(){for(;this->remove(0,1););}
#endif
unsigned int OnewayList::find(wchar_t findme,bool soft) const{
    //std::cout<<std::endl<<"Looking for "<<findme<<std::endl;
    if (!head){if(soft)return -1;else throw std::runtime_error("Trying to find entry in empty list");}
    Node* curp=head
#ifdef UNIQUE
                     .get()
#endif
        ;wchar_t pos=0;
    while (curp->data!=findme){curp=curp->next
#ifdef UNIQUE
               .get()
#endif
            ;if (curp)pos++; else if(soft)return -1;else throw std::runtime_error("No entry "+std::to_string(findme)+" found in list");}return pos;}
